config/routes.rb
Rails.application.routes.draw do

  
  devise_for :users
  get 'overview' => 'categories#index'
  get 'manage' => 'pages#manage'
  
  resources :categories do
    resources :transactions
  end
  
  resources :incomes
  resources :transactions 

  root 'pages#index'

  

end

app/models/income.rb
class Income < ActiveRecord::Base
  validates :name, presence: true
  validates :amount, presence: true, numericality: true
  belongs_to :user
  belongs_to :category
  
end

app/controllers/incomes_controller.rb
class IncomesController < ApplicationController
  before_action :set_income, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!
  
  # GET /incomes
  # GET /incomes.json
  def index
    @incomes = current_user.incomes.all
    @title = "All incomes"
  end

  # GET /incomes/1
  # GET /incomes/1.json
  def show
    
  end

  # GET /incomes/new
  def new
    @income = current_user.incomes.new
    @categories = current_user.categories.all
    @title = "Budget money for a category"
  end

  # GET /incomes/1/edit
  def edit
    @categories = current_user.categories.all
  end

  # POST /incomes
  # POST /incomes.json
  def create
    @income = current_user.incomes.new(income_params)
    
    respond_to do |format|
      if @income.save
        format.html { redirect_to @income, notice: 'Income was successfully created.' }
        format.json { render :show, status: :created, location: @income }
        format.js { render :show, status: :created, location: @income }
      else
        format.html { render :new }
        format.json { render json: @income.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /incomes/1
  # PATCH/PUT /incomes/1.json
  def update
    respond_to do |format|
      if @income.update(income_params)
        format.html { redirect_to @income, notice: 'Income was successfully updated.' }
        format.json { render :show, status: :ok, location: @income }
      else
        format.html { render :edit }
        format.json { render json: @income.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /incomes/1
  # DELETE /incomes/1.json
  def destroy
    @income.destroy
    respond_to do |format|
      format.html { redirect_to incomes_url, notice: 'Income was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_income
      @income = Income.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def income_params
      params.require(:income).permit(:amount, :category_id, :name)
    end
end

app/helpers/incomes_helper.rb
module IncomesHelper
end

app/views/incomes/_form.html.erb
<div class="col-md-6 col-md-offset-3">
  <%= form_for(@income, :html => {:class => "form"}) do |f| %>

    <% if @income.errors.any? %>
      <div id="error_explanation">
        <h2><%= pluralize(@income.errors.count, "error") %> prohibited this income from being saved:</h2>

        <ul>
          <% @income.errors.full_messages.each do |message| %>
            <li><%= message %></li>
          <% end %>
        </ul>
      </div>
    <% end %>
    
    <div class="form-group">
      <%= f.label :name %>
      <%= f.text_field :name, :class => "form-control" %>
    </div>
    
    <div class="form-group">
      <%= f.label :amount%>
      <div class="input-group">
        <div class="input-group-addon">$</div>
        <%= f.text_field :amount, :class => "form-control" %>
      </div>
    </div>

    <%= f.submit "Save", :class => "btn btn-default" %>
    <%= link_to "Delete", income_path(@income), method: :delete, data: { confirm: 'Are you sure?' }, :class => "btn btn-danger pull-right" %>        
  <% end %>
</div>

app/views/incomes/_form_all.html.erb
<div class="col-md-6 col-md-offset-3">
  
  <%= form_for(@income, :html => {:class => "form"}) do |f| %>

    <% if @income.errors.any? %>
      <div id="error_explanation">
        <h2><%= pluralize(@income.errors.count, "error") %> prohibited this income from being saved:</h2>

        <ul>
          <% @income.errors.full_messages.each do |message| %>
            <li><%= message %></li>
          <% end %>
        </ul>
      </div>
    <% end %>

    <div class="form-group">
      <%= f.label :category %> 
      <%= f.collection_select :category_id, @categories, :id, :name, {}, {:class => "form-control"} %>
    </div>

    <div class="form-group">
      <%= f.label :name, :class => "sr-only" %>
      <%= f.text_field :name, :class => "form-control", :placeholder => "Source ( i.e. Job )" %>
    </div>
    
    <div class="form-group">
      <%= f.label :amount, :class => "sr-only" %>
      <div class="input-group">
        <div class="input-group-addon">$</div>
        <%= f.text_field :amount, :class => "form-control", :placeholder => "1200.00" %>
      </div>
    </div>

    <%= f.submit "Save", :class => "btn btn-default" %>

  <% end %>
</div>

app/views/incomes/edit.html.erb
<%= render 'form_all' %>
<div class="row">
    <%= link_to "Delete", income_path(@income), method: :delete, data: { confirm: 'Are you sure?' }, :class => "btn btn-danger pull-right" %>        
</div>

app/views/incomes/index.html.erb
<div class="table-responsive">
  <table class="table table-hover">
    <caption>All sources of funds for budget category</caption>
    <thead>
    </thead>
    <tbody>
      <% @incomes.each do |income| %>
        <tr>
          <td><%= link_to income.name, edit_income_path(income) %></td>
          <td><%= number_to_currency(income.amount, :precision => 2)  %></td>
          <td><em><%= income.category.name %></em></td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>  
<%= link_to 'New Income', new_income_path, :class => "btn btn-default" %>

app/views/incomes/new.html.erb
<%= render 'form_all' %>

app/views/incomes/show.html.erb
<p>
  <strong>Amount:</strong>
  <%= @income.amount %>
</p>

<p>
  <strong>Name:</strong>
  <%= @income.name %>
</p>

app/views/incomes/show.js.erb
<%= j (render @comment) %>